import { IEffectsAction } from 'redux-effects-promise';
import { IKeyValue } from '../definitions.interface';
export declare class DictionariesActionBuilder {
    /**
     * @stable [09.10.2019]
     * @param {string} section
     * @returns {string}
     */
    static buildLoadActionType(section: string): string;
    /**
     * @stable [05.12.2019]
     * @param {string} section
     * @returns {string}
     */
    static buildLoadDoneActionType(section: string): string;
    /**
     * @stable [05.12.2019]
     * @param {string} section
     * @returns {string}
     */
    static buildLoadErrorActionType(section: string): string;
    /**
     * @stable [04.12.2019]
     * @param {string} section
     * @returns {string}
     */
    static buildSetActionType(section: string): string;
    /**
     * @stable [05.12.2019]
     * @returns {IEffectsAction}
     */
    static buildDestroyAllAction(): IEffectsAction;
    /**
     * @stable [04.12.2019]
     * @param {string} section
     * @param {TData} data
     * @returns {IEffectsAction}
     */
    static buildLoadAction<TData = IKeyValue>(section: string, data?: TData): IEffectsAction;
    /**
     * @stable [11.01.2020]
     * @param {string} section
     * @param {TData} data
     * @returns {IEffectsAction}
     */
    static buildLoadPlainAction<TData = IKeyValue>(section: string, data?: TData): IEffectsAction;
    /**
     * @stable [04.12.2019]
     * @param {string} section
     * @param {TData[] | TData} data
     * @returns {IEffectsAction}
     */
    static buildSetAction<TData = IKeyValue>(section: string, data?: TData | TData[]): IEffectsAction;
}
