import * as BPromise from 'bluebird';
import { IPlaceApi, IPlaceEntity, IPlaceGeoCodeRequestEntity, ISearchPlaceEntity, ISearchPlacesRequestEntity } from '../../../definition';
import { AnyT } from '../../../definitions.interface';
export declare class GooglePlaceApi implements IPlaceApi {
    private readonly asyncLibManager;
    private readonly fieldConverter;
    private readonly settings;
    /**
     * @stable [09.01.2020]
     * @param {IPlaceGeoCodeRequestEntity} req
     * @returns {Bluebird<IPlaceEntity[]> | AnyT}
     */
    getPlaceGeoCode(req: IPlaceGeoCodeRequestEntity): BPromise<IPlaceEntity[]> | AnyT;
    /**
     * @stable [10.01.2020]
     * @param {ISearchPlacesRequestEntity} request
     * @returns {Bluebird<ISearchPlaceEntity[]> | AnyT}
     */
    searchPlaces(request: ISearchPlacesRequestEntity): BPromise<ISearchPlaceEntity[]> | AnyT;
    /**
     * @stable [11.01.2020]
     * @param {string} requestCountry
     * @returns {IKeyValue}
     */
    private getDefaultParams;
    /**
     * @stable [10.01.2020]
     * @param {(resolve: (value?: TResult) => void) => void} callback
     * @returns {Bluebird<TResult>}
     */
    private readonly makePromise;
}
