import { IEffectsAction } from 'redux-effects-promise';
import { ITokenWrapper } from '../../definitions.interface';
export declare class ApplicationActionBuilder {
    /**
     * @stable [28.11.2019]
     * @param {string} error
     * @returns {IEffectsAction}
     */
    static buildCustomErrorAction(error: string): IEffectsAction;
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    static buildPrepareAction(): IEffectsAction;
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    static buildReadyAction(): IEffectsAction;
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    static buildNotReadyAction(): IEffectsAction;
    static buildAfterLoginAction(): IEffectsAction;
    static buildAuthorizedAction(payload?: ITokenWrapper): IEffectsAction;
    static buildUnauthorizedAction(): IEffectsAction;
    static buildAfterLogoutAction(): IEffectsAction;
    static buildAfterInitAction(): IEffectsAction;
    /**
     * @stable [23.10.2018]
     * @returns {string}
     */
    static buildPathActionType(): string;
    static buildAuthorizedActionType(): string;
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    static buildUnauthorizedActionType(): string;
    static buildInitActionType(): string;
    static buildAfterInitActionType(): string;
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    static buildLogoutActionType(): string;
    static buildMountActionType(): string;
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    static buildAfterLogoutActionType(): string;
    static buildAfterLoginActionType(): string;
}
