/// <reference types="react" />
import { BaseComponent } from '../base/base.component';
import { ICalendarProps } from '../../definition';
export declare class Calendar extends BaseComponent<ICalendarProps> {
    static readonly defaultProps: ICalendarProps;
    /**
     * @stable [04.01.2020]
     * @param {ICalendarProps} props
     */
    constructor(props: ICalendarProps);
    /**
     * @stable [04.01.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [04.01.2020]
     * @param {IGridColumnProps<ICalendarDayEntity>} payload
     * @returns {string}
     */
    private getColumnClassName;
    /**
     * @stable [07.01.2020]
     * @param {ICalendarDayEntity} entity
     * @returns {boolean}
     */
    private isDaySelected;
    /**
     * @stable [04.01.2020]
     * @param {ICalendarWeekEntity} item
     * @param {IGridColumnProps<ICalendarDayEntity>} column
     * @returns {JSX.Element}
     */
    private getCellElement;
    /**
     * @stable [04.01.2020]
     * @param {IGridColumnProps} payload
     */
    private onClick;
    /**
     * @stable [04.01.2020]
     * @param {IGridColumnProps} payload
     * @returns {ICalendarDayEntity}
     */
    private asCalendarDayEntity;
    /**
     * @stable [04.01.2020]
     * @returns {ICalendarEntity}
     */
    private readonly calendarEntity;
}
