"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var list_1 = require("../../list");
var card_component_1 = require("../card.component");
var CardList = /** @class */ (function (_super) {
    __extends(CardList, _super);
    function CardList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [02.05.2018]
     * @returns {JSX.Element}
     */
    CardList.prototype.getView = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement("div", { ref: 'container', className: util_1.toClassName('rac-list rac-card-list rac-flex-full', props.className) }, this.dataSource.map(function (item, index) { return _this.getItem(item, index); })));
    };
    /**
     * @stable [12.01.2019]
     * @param {IEntity} entity
     * @param {number} index
     * @returns {JSX.Element}
     */
    CardList.prototype.getItem = function (entity, index) {
        var props = this.props;
        var itemConfiguration = props.itemConfiguration || {};
        return (React.createElement(card_component_1.Card, { key: this.toRowKey(entity), entity: entity, rippled: itemConfiguration.rippled, className: util_1.toClassName("rac-list-item rac-list-item-" + index, util_1.calc(itemConfiguration.className, entity)), actionButtons: itemConfiguration.actionButtons && itemConfiguration.actionButtons(entity), actionIcons: itemConfiguration.actionIcons && itemConfiguration.actionIcons(entity), onClick: props.onSelect }, itemConfiguration.renderer(entity)));
    };
    return CardList;
}(list_1.BaseList));
exports.CardList = CardList;
//# sourceMappingURL=card-list.component.js.map