"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var inversify_1 = require("inversify");
var di_1 = require("../../di");
var util_1 = require("../../util");
var ControlledFieldFactory = /** @class */ (function () {
    function ControlledFieldFactory() {
        this.fields = new Map();
    }
    /**
     * @stable [11.01.2020]
     * @param {TConfig} config
     * @returns {JSX.Element}
     */
    ControlledFieldFactory.prototype.buildField = function (config) {
        return this.buildFields(config)[0];
    };
    /**
     * @stable [18.12.2019]
     * @param {TConfig} config
     * @returns {React.ReactNode}
     */
    ControlledFieldFactory.prototype.buildFields = function (config) {
        var _this = this;
        var actualFields = this.getFields(config);
        return (actualFields
            .map(function (actualFieldCfg) {
            var fieldConfiguration = actualFieldCfg.fieldConfiguration;
            var fieldEl = _this.fields.get(actualFieldCfg.type);
            return React.cloneElement(fieldEl, __assign({}, fieldConfiguration, _this.getExtraProps(config, actualFieldCfg, actualFields)));
        }));
    };
    /**
     * @stable [11.01.2020]
     * @param {IControlledFieldConfigEntity<TControlledFieldItemEntity extends IControlledFieldItemEntity<TControlledFieldItemsEnum>, TControlledFieldItemsEnum>} config
     * @returns {Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>}
     */
    ControlledFieldFactory.prototype.getFields = function (config) {
        return config.fields || [];
    };
    /**
     * @stable [11.01.2020]
     * @param {TControlledFieldItemEntity[]} fields
     * @returns {TControlledFieldItemEntity[]}
     */
    ControlledFieldFactory.prototype.sortFields = function (fields) {
        return R.sort(function (cfg1, cfg2) { return util_1.VALUE_ASC_SORTER_FN(cfg1.order, cfg2.order); }, fields);
    };
    /**
     * @stable [11.01.2020]
     * @param {TConfig} config
     * @param {IControlledFieldItemEntity<TControlledFieldItemsEnum, IFieldProps>} actualFieldCfg
     * @param {Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>} actualFields
     * @returns {IFieldProps}
     */
    ControlledFieldFactory.prototype.getExtraProps = function (config, actualFieldCfg, actualFields) {
        return {};
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DictionaryStoreProxyFactory),
        __metadata("design:type", Function)
    ], ControlledFieldFactory.prototype, "$dictionaryStoreProxyFactory", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.FormStoreProxyFactory),
        __metadata("design:type", Function)
    ], ControlledFieldFactory.prototype, "$formStoreProxyFactory", void 0);
    ControlledFieldFactory = __decorate([
        inversify_1.injectable()
    ], ControlledFieldFactory);
    return ControlledFieldFactory;
}());
exports.ControlledFieldFactory = ControlledFieldFactory;
//# sourceMappingURL=controlled-field-factory.service.js.map