"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var definition_1 = require("../../../definition");
var controlled_field_factory_service_1 = require("../controlled-field-factory.service");
var field_1 = require("../../field");
var di_1 = require("../../../di");
var util_1 = require("../../../util");
var ControlledPlaceFieldFactory = /** @class */ (function (_super) {
    __extends(ControlledPlaceFieldFactory, _super);
    /**
     * @stable [11.01.2020]
     */
    function ControlledPlaceFieldFactory() {
        var _this = _super.call(this) || this;
        _this.fields.set(definition_1.ControlledPlaceFieldItemsEnum.PLACE, React.createElement(field_1.PlaceField, null));
        return _this;
    }
    ControlledPlaceFieldFactory_1 = ControlledPlaceFieldFactory;
    /**
     * @stable [11.01.2020]
     * @param {IControlledPlaceFieldConfigEntity} config
     * @param {IControlledPlaceFieldItemEntity} actualFieldCfg
     * @param {IControlledPlaceFieldItemEntity[]} actualFields
     * @returns {IPlaceFieldProps}
     */
    ControlledPlaceFieldFactory.prototype.getExtraProps = function (config, actualFieldCfg, actualFields) {
        var _this = this;
        var props = _super.prototype.getExtraProps.call(this, config, actualFieldCfg, actualFields);
        var container = config.container;
        switch (actualFieldCfg.type) {
            case definition_1.ControlledPlaceFieldItemsEnum.PLACE:
                return __assign({}, props, { options: util_1.mapDictionaryEntity(config.container.props.dictionaries.places), onFilterChange: function (query) {
                        var payloadWrapper = { payload: { query: query } };
                        _this.$dictionaryStoreProxyFactory(container).dispatchLoadDictionary(definition_1.DictionariesEnum.PLACES, payloadWrapper);
                    } });
        }
        return props;
    };
    /**
     * @stable [11.01.2020]
     * @param {IControlledPlaceFieldConfigEntity} config
     * @returns {IControlledPlaceFieldItemEntity[]}
     */
    ControlledPlaceFieldFactory.prototype.getFields = function (config) {
        return [{
                type: definition_1.ControlledPlaceFieldItemsEnum.PLACE,
                fieldConfiguration: config.field,
            }];
    };
    var ControlledPlaceFieldFactory_1;
    ControlledPlaceFieldFactory = ControlledPlaceFieldFactory_1 = __decorate([
        di_1.provideInSingleton(ControlledPlaceFieldFactory_1),
        __metadata("design:paramtypes", [])
    ], ControlledPlaceFieldFactory);
    return ControlledPlaceFieldFactory;
}(controlled_field_factory_service_1.ControlledFieldFactory));
exports.ControlledPlaceFieldFactory = ControlledPlaceFieldFactory;
//# sourceMappingURL=controlled-place-field-factory.service.js.map