import * as React from 'react';
import { IActivateDialogConfigEntity, IDialog, IDialogProps, IDialogState } from '../../definition';
import { BaseComponent } from '../base/base.component';
export declare class Dialog<TProps extends IDialogProps = IDialogProps, TState extends IDialogState = IDialogState> extends BaseComponent<TProps, TState> implements IDialog<TProps, TState> {
    private onDeactivateCallback;
    /**
     * @stable [06.01.2020]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [05.01.2020]
     * @returns {React.ReactNode}
     */
    render(): React.ReactNode;
    /**
     * @stable [06.01.2020]
     * @param {IActivateDialogConfigEntity} payload
     */
    activate(payload?: IActivateDialogConfigEntity): void;
    /**
     * @stable [06.01.2020]
     */
    accept(): void;
    /**
     * @stable [05.01.2020]
     * @returns {string}
     */
    protected getDialogClassName(): string;
    /**
     * @stable [06.01.2020]
     */
    protected onAcceptClick(): void;
    /**
     * @stable [05.01.2020]
     */
    private onCloseClick;
    /**
     * @stable [05.01.2020]
     */
    private onDialogScrimClick;
    /**
     * @stable [05.01.2020]
     * @param {() => void} callback
     */
    private doClose;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly footerElement;
    /**
     * @stable [05.01.2020]
     * @returns {JSX.Element}
     */
    private readonly dialogScrimElement;
    /**
     * @stable [05.01.2020]
     * @returns {JSX.Element}
     */
    private readonly dialogBodyElement;
    /**
     * @stable [06.01.2020]
     * @returns {JSX.Element}
     */
    private readonly bodyElement;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly acceptable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly closable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isCloseButtonDisabled;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isAcceptButtonDisabled;
}
