/// <reference types="react" />
import { AnyT } from '../../../definitions.interface';
import { DateTimeLikeTypeT, IBaseEvent } from '../../../definition';
import { IDateFieldProps, IDateFieldState } from './date-field.interface';
import { BaseTextField } from '../textfield';
export declare class DateField<TProps extends IDateFieldProps = IDateFieldProps, TState extends IDateFieldState = IDateFieldState> extends BaseTextField<TProps, TState> {
    static readonly defaultProps: IDateFieldProps;
    private readonly dialogRef;
    /**
     * @stable [07.01.2020]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [07.01.2020]
     * @param {DateTimeLikeTypeT} currentRawValue
     */
    onChangeManually(currentRawValue: DateTimeLikeTypeT | AnyT): void;
    /**
     * @stable [09.01.2020]
     * @returns {JSX.Element}
     */
    protected getInputAttachmentElement(): JSX.Element;
    /**
     * @stable [09.01.2020]
     * @param {IBaseEvent} event
     */
    protected onClick(event: IBaseEvent): void;
    /**
     * @stable [07.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    protected decorateValueBeforeDisplaying(value: DateTimeLikeTypeT): string;
    /**
     * @stable [02.05.2019]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [07.01.2020]
     * @returns {string}
     */
    protected getFieldPattern(): string;
    /**
     * @stable [07.01.2020]
     * @returns {Array<string | RegExp>}
     */
    protected getFieldMask(): Array<string | RegExp>;
    /**
     * @stable [07.01.2020]
     * @returns {string}
     */
    protected readonly fieldFormat: string;
    /**
     * @stable [08.01.2020]
     */
    private setPreviousMonth;
    /**
     * @stable [08.01.2020]
     */
    private setNextMonth;
    /**
     * @stable [08.01.2020]
     * @param {number} duration
     */
    private changeMonth;
    /**
     * @stable [08.01.2020]
     * @param {number} year
     */
    private onChangeYear;
    /**
     * @stable [14.01.2020]
     */
    private onOk;
    /**
     * @stable [09.01.2020]
     * @param {ICalendarDayEntity} calendarDayEntity
     */
    private onAccept;
    /**
     * @stable [09.01.2020]
     */
    private onDialogDeactivate;
    /**
     * @stable [09.01.2020]
     * @param {() => void} callback
     */
    private onDialogClose;
    /**
     * @stable [24.02.2019]
     */
    private openDialog;
    /**
     * @stable [08.01.2020]
     * @param {ICalendarDayEntity} entity
     * @returns {boolean}
     */
    private isDaySelected;
    /**
     * @stable [07.01.2020]
     * @returns {Date}
     */
    private readonly selectedDate;
    /**
     * @stable [07.01.2020]
     * @param {DateTimeLikeTypeT} value
     * @returns {string}
     */
    private serializeValue;
    /**
     * @stable [08.01.2020]
     * @returns {string}
     */
    private dateToDisplay;
    /**
     * @stable [07.01.2020]
     * @returns {ICalendarEntity}
     */
    private readonly calendarEntity;
    /**
     * @stable [08.01.2020]
     * @returns {Date}
     */
    private readonly calendarDate;
    /**
     * @stable [08.01.2020]
     * @returns {string}
     */
    private readonly selectedYearPlaceholder;
    /**
     * stable [07.01.2020]
     * @returns {IDateTimeSettingsEntity}
     */
    private readonly dateTimeSettings;
    /**
     * @stable [24.02.2019]
     * @returns {Dialog}
     */
    private readonly dialog;
}
