"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var list_interface_1 = require("./list.interface");
var list_reducer_1 = require("./list.reducer");
var list_action_builder_1 = require("./list-action.builder");
var definition_1 = require("../../definition");
var TEST_SECTION = 'test';
describe('list.reducer', function () {
    describe(list_interface_1.LIST_MERGE_ACTION_TYPE, function () {
        // Update
        it('test1', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                totalCount: 3,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 2,
                    changes: { field1: 'value20' },
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value20', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Update
        it('test2', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                totalCount: 3,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 2,
                    changes: { id: 2, field1: 'value20' },
                    mergeStrategy: definition_1.EntityMergeStrategiesEnum.OVERRIDE,
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value20' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Update
        it('test3', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 2, field1: 'value2', field2: 'value4' },
                totalCount: 3,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 2,
                    changes: { id: 2, field1: 'value20' },
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value20', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 2, field1: 'value20', field2: 'value4' },
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Update
        it('test4', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 2, field1: 'value2', field2: 'value4' },
                totalCount: 3,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 2,
                    changes: { id: 2, field1: 'value20' },
                    mergeStrategy: definition_1.EntityMergeStrategiesEnum.OVERRIDE,
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value20' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 2, field1: 'value20' },
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Insert
        it('test5', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' }
                ],
                totalCount: 2,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 3,
                    changes: { id: 3, field1: 'value3', field2: 'value5' },
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 3, field1: 'value3', field2: 'value5' },
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Insert
        it('test6', function () {
            var reducedList = list_reducer_1.listReducer(Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' }
                ],
                totalCount: 2,
            }), list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 3,
                    changes: { id: 3, field1: 'value3', field2: 'value5' },
                    mergeStrategy: definition_1.EntityMergeStrategiesEnum.OVERRIDE,
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value3' },
                    { id: 2, field1: 'value2', field2: 'value4' },
                    { id: 3, field1: 'value3', field2: 'value5' }
                ],
                selected: { id: 3, field1: 'value3', field2: 'value5' },
                totalCount: 3,
            });
            expect(reducedList).toEqual(result);
        });
        // Insert
        it('test7', function () {
            var reducedList = list_reducer_1.listReducer(definition_1.INITIAL_LIST_ENTITY, list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 1,
                    changes: { id: 1, field1: 'value1', field2: 'value2' },
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value2' }
                ],
                selected: { id: 1, field1: 'value1', field2: 'value2' },
                totalCount: 1,
            });
            expect(reducedList).toEqual(result);
        });
        // Insert
        it('test8', function () {
            var reducedList = list_reducer_1.listReducer(definition_1.INITIAL_LIST_ENTITY, list_action_builder_1.ListActionBuilder.buildMergePlainAction(TEST_SECTION, {
                payload: {
                    id: 1,
                    changes: { id: 1, field1: 'value1', field2: 'value2' },
                    mergeStrategy: definition_1.EntityMergeStrategiesEnum.OVERRIDE,
                },
            }));
            var result = Object.assign({}, definition_1.INITIAL_LIST_ENTITY, {
                data: [
                    { id: 1, field1: 'value1', field2: 'value2' }
                ],
                selected: { id: 1, field1: 'value1', field2: 'value2' },
                totalCount: 1,
            });
            expect(reducedList).toEqual(result);
        });
    });
});
//# sourceMappingURL=list.reducer.spec.js.map