"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ripple_1 = require("@material/ripple");
var di_1 = require("../../di");
var util_1 = require("../../util");
var plugin_1 = require("./plugin");
var factory_1 = require("./factory");
var menu_1 = require("../menu");
var tabpanel_1 = require("../tabpanel");
var card_1 = require("../card");
var keyboard_1 = require("../keyboard");
var snackbar_1 = require("../snackbar");
// TODO UI plugins should contain an array (material.module.ts, perfect-scroll.module.ts, etc)
var uiPlugins = new Map();
di_1.bindToConstantValue(di_1.DI_TYPES.UIPlugins, uiPlugins);
/**
 * @stable [15.08.2018]
 */
uiPlugins.set(tabpanel_1.TabPanel, function (component) { return new plugin_1.TabPanelMaterialPlugin(component); });
/**
 * @stable [15.08.2018]
 */
uiPlugins.set(snackbar_1.Snackbar, function (component) { return new plugin_1.SnackbarMaterialPlugin(component); });
/**
 * @stable [18.06.2019]
 */
uiPlugins.set(menu_1.Menu, function (component) {
    return util_1.orNull(!component.centeredMenu, function () { return new plugin_1.MenuMaterialPlugin(component); });
});
/**
 * @stable [30.08.2019]
 */
uiPlugins.set(card_1.Card, function (component) {
    return util_1.ifNotFalseThanValue(component.props.rippled, function () { return new plugin_1.MaterialPlugin(component, ripple_1.MDCRipple); });
});
/**
 * @stable [08.05.2018]
 */
uiPlugins.set(keyboard_1.KeyboardKey, function (component) { return new plugin_1.MaterialPlugin(component, ripple_1.MDCRipple); });
/**
 * @stable [27.05.2018]
 */
di_1.appContainer.bind(di_1.DI_TYPES.UIFactory).to(factory_1.UIMaterialFactory).inSingletonScope();
// TODO
require("../icon/icon-factory/default/ui-default-icon-factory.module");
/**
 * @stable [27.05.2018]
 */
util_1.addClassNameToBody('mdc-typography');
//# sourceMappingURL=material.module.js.map