"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var perfect_scrollbar_1 = require("perfect-scrollbar");
var definition_1 = require("../../definition");
var di_1 = require("../../di");
var util_1 = require("../../util");
var PerfectScrollPlugin = /** @class */ (function () {
    /**
     * @stable [04.12.2019]
     * @param {} component
     */
    function PerfectScrollPlugin(component) {
        this.component = component;
        this.doUpdate = this.doUpdate.bind(this);
    }
    /**
     * @stable [04.12.2019]
     */
    PerfectScrollPlugin.prototype.componentDidMount = function () {
        this.tryRegisterPs();
    };
    /**
     * @stable [04.12.2019]
     */
    PerfectScrollPlugin.prototype.componentDidUpdate = function () {
        this.tryRegisterPs();
        this.doUpdate();
    };
    /**
     * @stable [04.12.2019]
     */
    PerfectScrollPlugin.prototype.componentWillUnmount = function () {
        this.doDestroy();
    };
    /**
     * @stable [06.12.2019]
     */
    PerfectScrollPlugin.prototype.doUpdate = function () {
        if (util_1.isDef(this.ps)) {
            try {
                this.ps.update();
            }
            catch (e) {
                // Do nothing... (https://github.com/mdbootstrap/perfect-scrollbar/issues/827)
            }
        }
    };
    /**
     * @stable [06.12.2019]
     */
    PerfectScrollPlugin.prototype.tryRegisterPs = function () {
        var component = this.component;
        var selfRef = component.getSelf();
        if (R.isNil(selfRef)) {
            this.doDestroy();
            return;
        }
        if (this.doesPsExist) {
            return;
        }
        this.ps = new perfect_scrollbar_1.default(selfRef, __assign({ wheelSpeed: 2, wheelPropagation: false, minScrollbarLength: 20 }, component.props.perfectScroll));
        this.resizeUnsubscriber = this.domAccessor.captureEvent({
            eventName: definition_1.EventsEnum.RESIZE,
            callback: this.doUpdate,
        });
    };
    /**
     * @stable [06.12.2019]
     */
    PerfectScrollPlugin.prototype.doDestroy = function () {
        if (this.doesPsExist) {
            this.ps.destroy();
            this.ps = null;
        }
        if (util_1.isFn(this.resizeUnsubscriber)) {
            this.resizeUnsubscriber();
            this.resizeUnsubscriber = null;
        }
    };
    Object.defineProperty(PerfectScrollPlugin.prototype, "doesPsExist", {
        /**
         * @stable [06.12.2019]
         * @returns {boolean}
         */
        get: function () {
            return !R.isNil(this.ps);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DomAccessor),
        __metadata("design:type", Object)
    ], PerfectScrollPlugin.prototype, "domAccessor", void 0);
    return PerfectScrollPlugin;
}());
exports.PerfectScrollPlugin = PerfectScrollPlugin;
//# sourceMappingURL=perfect-scroll.plugin.js.map