import * as React from 'react';
import { BaseStoreProxy } from '../base-store.proxy';
import { IRouterStoreProxy, IRouterStoreProxyFactoryConfigEntity, IUniversalContainer, IUniversalContainerProps, IUniversalStoreEntity } from '../../../../definition';
export declare class RouterStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> extends BaseStoreProxy<TStore, TProps> implements IRouterStoreProxy {
    readonly container: IUniversalContainer<TProps>;
    /**
     * @stable [20.12.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IUniversalContainer<TProps>);
    /**
     * @stable [20.12.2019]
     * @param {number} depth
     */
    goBack(depth?: number): void;
    /**
     * @stable [20.12.2019]
     */
    navigateBack(): void;
    /**
     * @stable [19.12.2019]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    buildNavigationSteps(factory: (cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element): React.ReactNode[];
}
