"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var base_store_proxy_1 = require("../base-store.proxy");
var action_1 = require("../../../../action");
var util_1 = require("../../../../util");
var RouterStoreProxy = /** @class */ (function (_super) {
    __extends(RouterStoreProxy, _super);
    /**
     * @stable [20.12.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    function RouterStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.navigateBack = _this.navigateBack.bind(_this);
        return _this;
    }
    /**
     * @stable [20.12.2019]
     * @param {number} depth
     */
    RouterStoreProxy.prototype.goBack = function (depth) {
        this.dispatchAnyAction(action_1.RouterActionBuilder.buildNavigateBackPlainAction(depth));
    };
    /**
     * @stable [20.12.2019]
     */
    RouterStoreProxy.prototype.navigateBack = function () {
        this.goBack();
    };
    /**
     * @stable [19.12.2019]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    RouterStoreProxy.prototype.buildNavigationSteps = function (factory) {
        var _this = this;
        var entities = util_1.selectStackWrapperItemEntities(this.props) || [];
        var length = entities.length;
        return entities
            .map(function (item, index) {
            var last = index === length - 1;
            var stepElement = factory({ item: item, first: index === 0, last: last });
            if (R.isNil(stepElement)) {
                return null;
            }
            return React.cloneElement(stepElement, __assign({ key: item.url }, (last
                ? {}
                : util_1.handlerPropsFactory(function () { return _this.goBack(length - entities.indexOf(item) - 1); }))));
        })
            .filter(util_1.NOT_NIL_VALUE_PREDICATE);
    };
    return RouterStoreProxy;
}(base_store_proxy_1.BaseStoreProxy));
exports.RouterStoreProxy = RouterStoreProxy;
//# sourceMappingURL=router-store.proxy.js.map