"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var inversify_1 = require("inversify");
var google_libphonenumber_1 = require("google-libphonenumber");
var di_1 = require("../../di");
var util_1 = require("../../util");
var PhoneConverter = /** @class */ (function () {
    function PhoneConverter() {
        this.phoneUtilInstance = google_libphonenumber_1.PhoneNumberUtil.getInstance();
    }
    /**
     * @stable [24.12.2019]
     * @param {IPhoneConfigEntity<libphonenumber.PhoneNumberFormat>} config
     * @returns {string}
     */
    PhoneConverter.prototype.format = function (config) {
        var value = config.value, format = config.format;
        if (R.isNil(value)) {
            return '';
        }
        var phoneNumber = this.parse(config);
        return this.phoneUtilInstance.isValidNumber(phoneNumber)
            ? this.phoneUtilInstance.format(phoneNumber, format)
            : util_1.isString(value) ? value : String(value);
    };
    /**
     * @stable [24.12.2019]
     * @param {IPhoneConfigEntity<libphonenumber.PhoneNumberFormat>} config
     * @returns {libphonenumber.PhoneNumber}
     */
    PhoneConverter.prototype.parse = function (config) {
        var value = config.value, countryAbbr = config.countryAbbr;
        if (R.isNil(value)) {
            return null;
        }
        var v = util_1.isString(value) ? value : String(value);
        try {
            return this.phoneUtilInstance.parse(v, util_1.nvl(countryAbbr, this.settings.phone.countryAbbr));
        }
        catch (e) {
            return null;
        }
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], PhoneConverter.prototype, "settings", void 0);
    PhoneConverter = __decorate([
        inversify_1.injectable()
    ], PhoneConverter);
    return PhoneConverter;
}());
exports.PhoneConverter = PhoneConverter;
//# sourceMappingURL=phone-converter.service.js.map