"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _a;
var R = require("ramda");
/**
 * @stable [15.11.2019]
 */
var CronPartTypesEnum;
(function (CronPartTypesEnum) {
    CronPartTypesEnum[CronPartTypesEnum["DAY_OF_MONTH"] = 0] = "DAY_OF_MONTH";
    CronPartTypesEnum[CronPartTypesEnum["DAY_OF_WEEK"] = 1] = "DAY_OF_WEEK";
    CronPartTypesEnum[CronPartTypesEnum["HOUR"] = 2] = "HOUR";
    CronPartTypesEnum[CronPartTypesEnum["MINUTE"] = 3] = "MINUTE";
    CronPartTypesEnum[CronPartTypesEnum["MONTH_OF_YEAR"] = 4] = "MONTH_OF_YEAR";
    CronPartTypesEnum[CronPartTypesEnum["YEAR"] = 5] = "YEAR";
})(CronPartTypesEnum = exports.CronPartTypesEnum || (exports.CronPartTypesEnum = {}));
/**
 * @stable [15.12.2019]
 */
var CronPeriodsEnum;
(function (CronPeriodsEnum) {
    CronPeriodsEnum[CronPeriodsEnum["COMPLEX_RULE"] = 0] = "COMPLEX_RULE";
    CronPeriodsEnum[CronPeriodsEnum["DAILY"] = 1] = "DAILY";
    CronPeriodsEnum[CronPeriodsEnum["MONTHLY"] = 2] = "MONTHLY";
    CronPeriodsEnum[CronPeriodsEnum["NO_REPETITIONS"] = 3] = "NO_REPETITIONS";
    CronPeriodsEnum[CronPeriodsEnum["WEEKLY"] = 4] = "WEEKLY";
    CronPeriodsEnum[CronPeriodsEnum["YEARLY"] = 5] = "YEARLY";
})(CronPeriodsEnum = exports.CronPeriodsEnum || (exports.CronPeriodsEnum = {}));
/**
 * @stable [14.12.2019]
 */
exports.CRON_ALL_VALUES_SYMBOL = '*';
exports.CRON_LAST_DAY_OF_MONTH = 0;
exports.CRON_LAST_DAY_SYMBOL = 'L';
exports.CRON_NEVER_EXECUTABLE_SYMBOL = 'N';
/**
 * @stable [15.11.2019]
 */
exports.CRON_PART_TYPE_RANGES = Object.freeze((_a = {},
    _a[CronPartTypesEnum.MINUTE] = [0, 59],
    _a[CronPartTypesEnum.HOUR] = [0, 23],
    _a[CronPartTypesEnum.DAY_OF_MONTH] = [1, 31],
    _a[CronPartTypesEnum.MONTH_OF_YEAR] = [1, 12],
    _a[CronPartTypesEnum.DAY_OF_WEEK] = [0, 6],
    // -6 - The last Friday of the month
    // -5 - The last Thursday of the month
    // -4 - The last Wednesday of the month
    // -3 - The last Tuesday of the month
    // -2 - The last Monday of the month
    // -1 - The last Sunday of the month
    // 0 - Sunday
    // 6 - Saturday
    _a[CronPartTypesEnum.YEAR] = [1900, 2100],
    _a));
/**
 * @stable [14.12.2019]
 */
exports.CRON_PART_TYPE_RANGES_VALUES = Object.freeze((function () {
    var result = {};
    R.forEachObjIndexed(function (value, key) {
        var allValues = [];
        for (var index = value[0]; index <= value[1]; index++) {
            allValues.push(index);
        }
        result[key] = allValues;
    }, exports.CRON_PART_TYPE_RANGES);
    return result;
})());
/**
 * @stable [14.12.2019]
 */
exports.CRON_ALL_DAYS_OF_MONTH_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.DAY_OF_MONTH];
exports.CRON_ALL_DAYS_OF_WEEK_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.DAY_OF_WEEK];
exports.CRON_ALL_HOURS_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.HOUR];
exports.CRON_ALL_MINUTES_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.MINUTE];
exports.CRON_ALL_MONTHS_OF_YEAR_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.MONTH_OF_YEAR];
exports.CRON_ALL_YEARS_VALUES = exports.CRON_PART_TYPE_RANGES_VALUES[CronPartTypesEnum.YEAR];
//# sourceMappingURL=cron-definition.interface.js.map