import * as moment from 'moment';
import { ICalendarEntityWrapper, ICurrentWrapper, IDateWrapper, IDaysLabelsWrapper, IDaysWrapper, IDayWrapper, IDurationWrapper, IEntityIdTWrapper, IFromToEntity, IIndexWrapper, IInputFormatWrapper, IInputTimeFormatWrapper, IIsoWeekWrapper, IMaxDateWrapper, IMinDateWrapper, IMonthWrapper, INextWrapper, IOutputFormatWrapper, IOutputTimeFormatWrapper, IPreviousWrapper, IStrictWrapper, ITimeWrapper, ITodayWrapper, IUnitWrapper, IUseSyntheticCalendarWrapper, IYearWrapper, IZoneWrapper, StringNumberT } from '../definitions.interface';
/**
 * @stable [22.12.2019]
 */
export declare type DateTimeLikeTypeT = string | Date;
export declare type MomentT = moment.Moment;
export declare const DAYS_OF_WEEK: ReadonlyArray<{
    id: number;
    name: string;
}>;
/**
 * @stable [17.12.2019]
 */
export interface IDateTimeConfigEntity<TDate = Date> extends IDateWrapper<DateTimeLikeTypeT | TDate>, IDurationWrapper<StringNumberT>, IIndexWrapper, IInputFormatWrapper, IInputTimeFormatWrapper, IIsoWeekWrapper, IOutputFormatWrapper, IOutputTimeFormatWrapper, IStrictWrapper, ITimeWrapper, IUnitWrapper<string>, IZoneWrapper {
}
/**
 * @stable [08.01.2020]
 */
export interface IDateTimeRangeConfigEntity extends IDateWrapper<Date>, IMaxDateWrapper<Date>, IMinDateWrapper<Date> {
}
/**
 * @stable [04.01.2020]
 */
export interface ICalendarConfigEntity<TDate = Date> extends IDateTimeConfigEntity<TDate>, IUseSyntheticCalendarWrapper {
}
/**
 * @stable [07.01.2020]
 */
export interface IDayOfYearEntity extends IDayWrapper, IFromToEntity<boolean>, IMonthWrapper, IYearWrapper {
}
/**
 * @stable [07.01.2020]
 */
export interface IFromToDayOfYearEntity extends IFromToEntity<IDayOfYearEntity> {
}
/**
 * @stable [03.01.2020]
 */
export interface ICalendarDayEntity extends ICurrentWrapper<boolean>, IDateWrapper<Date>, IDayOfYearEntity, INextWrapper<boolean>, IPreviousWrapper<boolean>, ITodayWrapper<boolean> {
}
/**
 * @stable [03.01.2020]
 */
export interface ICalendarWeekEntity extends IEntityIdTWrapper {
    [index: number]: ICalendarDayEntity;
}
/**
 * @stable [03.01.2020]
 */
export interface ICalendarEntity extends IDaysWrapper<ICalendarWeekEntity[]>, IDaysLabelsWrapper<string[]> {
}
/**
 * @stable [04.01.2020]
 */
export interface ICalendarEntityWrapperEntity extends ICalendarEntityWrapper<ICalendarEntity> {
}
