import { IFormEntity, IFormWrapperEntity, IGenericFieldEntity, IGenericFormEntity } from '../definition';
import { IEntity } from '../definitions.interface';
/**
 * @stable [16.11.2019]
 * @param {IFormWrapperEntity<TEntity extends IEntity>} formWrapperEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldValue: <TEntity extends IEntity = IEntity>(formWrapperEntity: IFormWrapperEntity<TEntity>, fieldProps: IGenericFieldEntity) => any;
/**
 * @stable [24.12.2019]
 * @param {IFormWrapperEntity<TEntity extends IEntity>} formWrapperEntity
 * @param {IGenericFieldEntity} fieldProps
 * @param {IGenericFieldEntity} defaultFieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldDisplayValue: <TEntity extends IEntity = IEntity>(formWrapperEntity: IFormWrapperEntity<TEntity>, fieldProps: IGenericFieldEntity, defaultFieldProps?: IGenericFieldEntity) => any;
/**
 * @stable [16.11.2019]
 * @param {IFormWrapperEntity<TEntity extends IEntity>} formWrapperEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldOriginalValue: <TEntity extends IEntity = IEntity>(formWrapperEntity: IFormWrapperEntity<TEntity>, fieldProps: IGenericFieldEntity) => any;
/**
 * @stable [25.09.2019]
 * @param {IFormEntity<TEntity>} entity
 * @returns {boolean}
 */
export declare const isFormEntityDisabled: <TEntity extends IEntity = IEntity>(entity: IFormEntity<TEntity>) => boolean;
/**
 * @stable [26.12.2019]
 * @param {IFormEntity<TEntity extends IEntity>} formEntity
 * @returns {boolean}
 */
export declare const isFormEntityDirty: <TEntity extends IEntity = IEntity>(formEntity: IFormEntity<TEntity>) => boolean;
/**
 * @stable [25.10.2019]
 * @param {IFormEntity<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormEntityValid: <TEntity extends IEntity = IEntity>(entity: IFormEntity<TEntity>) => boolean;
/**
 * @stable [25.10.2019]
 * @param {IFormWrapperEntity<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormWrapperEntityInProgress: <TEntity extends IEntity = IEntity>(entity: IFormWrapperEntity<TEntity>) => boolean;
/**
 * @stable [25.09.2019]
 * @param {IGenericFormEntity} formEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldReadOnly: (formEntity: IGenericFormEntity, fieldProps: IGenericFieldEntity) => boolean;
