import { IKeyValue } from '../definitions.interface';
import { IValidationResultEntity, ValidatorRuleEnum } from '../definition';
/**
 * @stable [06.12.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const numberLikeChecker: (value: any) => boolean;
/**
 * @stable [06.12.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const optionalNumberLikeChecker: (value: any) => boolean;
/**
 * @stable [06.12.2019]
 * @param value
 * @returns {boolean}
 */
export declare const stringChecker: (value: any) => boolean;
/**
 * @stable [06.12.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const notEmptyString: (value: any) => boolean;
/**
 * @stable [06.12.2019]
 * @param value
 * @returns {boolean}
 */
export declare const digitChecker: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 */
export declare const ValidationRules: {
    [ValidatorRuleEnum.DIGIT]: (value: any) => boolean;
    [ValidatorRuleEnum.NOT_EMPTY_STRING]: (value: any) => boolean;
    [ValidatorRuleEnum.NUMBER_LIKE]: (value: any) => boolean;
    [ValidatorRuleEnum.OPTIONAL_NUMBER_LIKE]: (value: any) => boolean;
    [ValidatorRuleEnum.STRING]: (value: any) => boolean;
};
/**
 * @stable [06.12.2019]
 * @param {Record<string, ValidatorRuleEnum[]>} payloads
 * @param {IKeyValue} checkedObject
 * @returns {IValidationResultEntity}
 */
export declare const validate: <TEntity extends IKeyValue = IKeyValue>(payloads: Record<string, ValidatorRuleEnum[]>, checkedObject: TEntity) => IValidationResultEntity;
