import { IAlwaysDirtyWrapper, ICenteredMenuWrapper, IChangeableWrapper, IClearActionRenderedWrapper, IDirtyWrapper, IDisabledWrapper, IDisplayValueOnlyWrapper, IEditedWrapper, IErrorWrapper, IExpandActionRenderedWrapper, IFocusedWrapper, IHeaderRenderedWrapper, IHighlightOddWrapper, IHoveredWrapper, IIndexedWrapper, IKeyboardOpenWrapper, ILoadingWrapper, IMenuRenderedWrapper, IMultiWrapper, IPlaceActionRenderedWrapper, IPlainValueWrapper, IPreventFocusWrapper, IProgressWrapper, IReadOnlyWrapper, IReadyWrapper, IRefreshOnUpdateWrapper, IRemoteFilterWrapper, IRenderedWrapper, IRequiredWrapper, ISelectableWrapper, ISelectedWrapper, ISortableWrapper, ISyntheticCursorWrapper, IUseFilterWrapper, IUseKeyboardWrapper, IUseZipCodeWrapper, IValidWrapper, IVisibleWrapper, IWaitingForDataWrapper } from '../definitions.interface';
/**
 * @stable [24.10.2019]
 * @param {IValidWrapper} validEntity
 * @returns {boolean}
 */
export declare const isValid: (validEntity: IValidWrapper) => boolean;
/**
 * @stable [24.10.2019]
 * @param {IPreventFocusWrapper} preventFocusEntity
 * @returns {boolean}
 */
export declare const isFocusPrevented: (preventFocusEntity: IPreventFocusWrapper) => boolean;
/**
 * @stable [24.10.2019]
 * @param {IProgressWrapper} progressEntity
 * @returns {boolean}
 */
export declare const inProgress: (progressEntity: IProgressWrapper) => boolean;
/**
 * @stable [28.11.2019]
 * @param {IReadyWrapper} entity
 * @returns {boolean}
 */
export declare const isReady: (entity: IReadyWrapper) => boolean;
/**
 * @stable [28.11.2019]
 * @param {IErrorWrapper} entity
 * @returns {boolean}
 */
export declare const doesErrorExist: (entity: IErrorWrapper<string | boolean>) => boolean;
/**
 * @stable [24.10.2019]
 * @param {IUseKeyboardWrapper} useKeyboardEntity
 * @returns {boolean}
 */
export declare const isKeyboardUsed: (useKeyboardEntity: IUseKeyboardWrapper) => boolean;
/**
 * @stable [25.10.2019]
 * @param {IVisibleWrapper} visibleEntity
 * @returns {boolean}
 */
export declare const isVisible: (visibleEntity: IVisibleWrapper) => boolean;
/**
 * @stable [30.10.2019]
 * @param {IFocusedWrapper} wrapper
 * @returns {boolean}
 */
export declare const isFocused: (wrapper: IFocusedWrapper) => boolean;
/**
 * @stable [26.10.2019]
 * @param {IHighlightOddWrapper} highlightOddEntity
 * @param {number} index
 * @returns {boolean}
 */
export declare const isHighlightOdd: (highlightOddEntity: IHighlightOddWrapper, index: number) => boolean;
/**
 * @stable [26.10.2019]
 * @param {IIndexedWrapper} indexedEntity
 * @returns {boolean}
 */
export declare const isIndexed: (indexedEntity: IIndexedWrapper) => boolean;
/**
 * @stable [03.01.2019]
 * @param {IHeaderRenderedWrapper} headerRendered
 * @returns {boolean}
 */
export declare const isHeaderRendered: (headerRendered: IHeaderRenderedWrapper) => boolean;
/**
 * @stable [11.01.2020]
 * @param {IRenderedWrapper} value
 * @returns {boolean}
 */
export declare const isRendered: (value: IRenderedWrapper) => boolean;
/**
 * @stable [26.10.2019]
 * @param {IEditedWrapper} editedEntity
 * @returns {boolean}
 */
export declare const isEdited: (editedEntity: IEditedWrapper) => boolean;
/**
 * @stable [26.10.2019]
 * @param {ISortableWrapper} sortableEntity
 * @returns {boolean}
 */
export declare const isSortable: (sortableEntity: ISortableWrapper) => boolean;
/**
 * @stable [27.10.2019]
 * @param {IDisabledWrapper} disabledEntity
 * @returns {boolean}
 */
export declare const isDisabled: (disabledEntity: IDisabledWrapper<boolean>) => boolean;
/**
 * @stable [27.10.2019]
 * @param {IDisabledWrapper} selectedWrapper
 * @returns {boolean}
 */
export declare const isSelected: (selectedWrapper: ISelectedWrapper<boolean>) => boolean;
/**
 * @stable [27.10.2019]
 * @param {ISelectableWrapper} selectableWrapper
 * @returns {boolean}
 */
export declare const isSelectable: (selectableWrapper: ISelectableWrapper<boolean>) => boolean;
/**
 * @stable [27.10.2019]
 * @param {IHoveredWrapper} hoveredWrapper
 * @returns {boolean}
 */
export declare const isHovered: (hoveredWrapper: IHoveredWrapper) => boolean;
/**
 * @stable [27.10.2019]
 * @param {IExpandActionRenderedWrapper} wrapper
 * @returns {boolean}
 */
export declare const isExpandActionRendered: (wrapper: IExpandActionRenderedWrapper) => boolean;
/**
 * @stable [01.12.2019]
 * @param {IClearActionRenderedWrapper} wrapper
 * @returns {boolean}
 */
export declare const isClearActionRendered: (wrapper: IClearActionRenderedWrapper) => boolean;
/**
 * @stable [28.10.2019]
 * @param {IReadOnlyWrapper} readOnlyWrapper
 * @returns {boolean}
 */
export declare const isReadOnly: (readOnlyWrapper: IReadOnlyWrapper) => boolean;
/**
 * @stable [28.10.2019]
 * @param {IChangeableWrapper} changeableWrapper
 * @returns {boolean}
 */
export declare const isChangeable: (changeableWrapper: IChangeableWrapper) => boolean;
/**
 * @stable [28.10.2019]
 * @param {IKeyboardOpenWrapper} wrapper
 * @returns {boolean}
 */
export declare const isKeyboardOpen: (wrapper: IKeyboardOpenWrapper) => boolean;
/**
 * @stable [29.10.2019]
 * @param {IRequiredWrapper} wrapper
 * @returns {boolean}
 */
export declare const isRequired: (wrapper: IRequiredWrapper<boolean>) => boolean;
/**
 * @stable [30.10.2019]
 * @param {ISyntheticCursorWrapper} wrapper
 * @returns {boolean}
 */
export declare const isSyntheticCursorUsed: (wrapper: ISyntheticCursorWrapper<boolean>) => boolean;
/**
 * @stable [13.11.2019]
 * @param {IMultiWrapper} wrapper
 * @returns {boolean}
 */
export declare const isMulti: (wrapper: IMultiWrapper) => boolean;
/**
 * @stable [23.11.2019]
 * @param {ICenteredMenuWrapper} wrapper
 * @returns {boolean}
 */
export declare const isCenteredMenu: (wrapper: ICenteredMenuWrapper) => boolean;
/**
 * @stable [23.11.2019]
 * @param {IRemoteFilterWrapper} wrapper
 * @returns {boolean}
 */
export declare const isRemoteFilterApplied: (wrapper: IRemoteFilterWrapper) => boolean;
/**
 * @stable [11.01.2020]
 * @param {IMenuRenderedWrapper} wrapper
 * @returns {boolean}
 */
export declare const isMenuOpened: (wrapper: IMenuRenderedWrapper) => boolean;
/**
 * @stable [11.01.2020]
 * @param {IWaitingForDataWrapper} wrapper
 * @returns {boolean}
 */
export declare const isWaitingForData: (wrapper: IWaitingForDataWrapper) => boolean;
/**
 * @stable [23.11.2019]
 * @param {IUseFilterWrapper} wrapper
 * @returns {boolean}
 */
export declare const isFilterUsed: (wrapper: IUseFilterWrapper) => boolean;
/**
 * @stable [22.11.2019]
 * @param {ILoadingWrapper} entity
 * @returns {boolean}
 */
export declare const isBeingLoaded: (entity: ILoadingWrapper) => boolean;
/**
 * @stable [26.11.2019]
 * @param {IPlaceActionRenderedWrapper} entity
 * @returns {boolean}
 */
export declare const isPlaceActionRendered: (entity: IPlaceActionRenderedWrapper) => boolean;
/**
 * @stable [11.01.2020]
 * @param {IUseZipCodeWrapper} entity
 * @returns {boolean}
 */
export declare const isUseZipCode: (entity: IUseZipCodeWrapper) => boolean;
/**
 * @stable [14.01.2020]
 * @param {IPlainValueWrapper} entity
 * @returns {boolean}
 */
export declare const isPlainValueApplied: (entity: IPlainValueWrapper) => boolean;
/**
 * @stable [19.12.2019]
 * @param {IRefreshOnUpdateWrapper} entity
 * @returns {boolean}
 */
export declare const isRefreshOnUpdate: (entity: IRefreshOnUpdateWrapper) => boolean;
/**
 * @stable [21.12.2019]
 * @param {IDisplayValueOnlyWrapper} entity
 * @returns {boolean}
 */
export declare const isDisplayValueOnly: (entity: IDisplayValueOnlyWrapper) => boolean;
/**
 * @stable [26.12.2019]
 * @param {IAlwaysDirtyWrapper} entity
 * @returns {boolean}
 */
export declare const isAlwaysDirty: (entity: IAlwaysDirtyWrapper) => boolean;
/**
 * @stable [26.12.2019]
 * @param {IDirtyWrapper} entity
 * @returns {boolean}
 */
export declare const isDirty: (entity: IDirtyWrapper) => boolean;
