"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var R = require("ramda");
var di_1 = require("../di");
var util_1 = require("../util");
var LogManagerEventPayloadFactory = /** @class */ (function () {
    function LogManagerEventPayloadFactory() {
    }
    LogManagerEventPayloadFactory_1 = LogManagerEventPayloadFactory;
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    LogManagerEventPayloadFactory.prototype.provideAction = function (category, eventAction, payload) {
        return eventAction;
    };
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    LogManagerEventPayloadFactory.prototype.provideCategory = function (category, eventAction, payload) {
        return this.environment.host + ":" + category;
    };
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    LogManagerEventPayloadFactory.prototype.provideLabel = function (category, eventAction, payload) {
        var state = this.store.getState();
        var user = state.user;
        var appVersion = this.environment.appVersion;
        var browserName = this.environment.browserName;
        var browserVersion = this.environment.browserVersion;
        return "" + (R.isNil(user) || R.isNil(user.id) ? '' : user.id + ":" + user.name + ":") + appVersion + ":" + this.dc.getAppOnlineLifeTimeInHours() + ":" + this.dc.fromDateTimeToDateTime(this.dc.getCurrentDate()) + ":" + browserName + ":" + browserVersion + ":" + util_1.getCurrentUrlPath() + this.getEventLabel(payload);
    };
    /**
     * @stable [17.10.2019]
     * @param {AnyT} payload
     * @returns {string}
     */
    LogManagerEventPayloadFactory.prototype.getEventLabel = function (payload) {
        if (R.isNil(payload)) {
            return '[-]';
        }
        try {
            return ":" + JSON.stringify(payload);
        }
        catch (e) {
            LogManagerEventPayloadFactory_1.logger.error('[$LogManagerEventPayloadFactory][getEventLabel] The system error has occurred:', e);
            try {
                return ":" + String(payload);
            }
            catch (ignored) {
                // Do nothing
            }
        }
    };
    var LogManagerEventPayloadFactory_1;
    LogManagerEventPayloadFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('LogManagerEventPayloadFactory');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DateConverter),
        __metadata("design:type", Object)
    ], LogManagerEventPayloadFactory.prototype, "dc", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Environment),
        __metadata("design:type", Object)
    ], LogManagerEventPayloadFactory.prototype, "environment", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], LogManagerEventPayloadFactory.prototype, "store", void 0);
    LogManagerEventPayloadFactory = LogManagerEventPayloadFactory_1 = __decorate([
        inversify_1.injectable()
    ], LogManagerEventPayloadFactory);
    return LogManagerEventPayloadFactory;
}());
exports.LogManagerEventPayloadFactory = LogManagerEventPayloadFactory;
//# sourceMappingURL=log-manager-event-payload-factory.service.js.map